"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Dialog = exports.HeaderTitle = void 0;

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _reactHooksShareable = require("react-hooks-shareable");

var _Typography = require("../Typography");

var _Header = require("./components/Header");

var _Footer = require("./components/Footer");

var _Content = require("./components/Content");

var _BaseDialog = require("./BaseDialog");

var _twoLinesClamp = require("../utils/twoLinesClamp");

var _excluded = ["width", "header", "controls", "focusDialog", "children"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var HeaderTitle = (0, _styledComponents.default)(_Typography.Typography).attrs({
  variant: 'dialog-heading'
}).withConfig({
  displayName: "Dialog__HeaderTitle",
  componentId: "sc-v9vg1z-0"
})(["", ""], _twoLinesClamp.twoLinesClamp);
exports.HeaderTitle = HeaderTitle;

var Dialog = _ref => {
  var {
    width,
    header,
    controls,
    focusDialog = true,
    children
  } = _ref,
      modalProps = _objectWithoutProperties(_ref, _excluded);

  var {
    atTop,
    atBottom,
    scrollRef
  } = (0, _reactHooksShareable.useScrollPosition)();
  return /*#__PURE__*/_react.default.createElement(_BaseDialog.BaseDialog, _extends({
    focusDialog: focusDialog,
    width: width,
    verticallyCenter: true
  }, modalProps), header !== undefined ? /*#__PURE__*/_react.default.createElement(_BaseDialog.DialogHeader, null, /*#__PURE__*/_react.default.createElement(_Header.Header, {
    shadowHidden: atTop !== false
  }, header)) : null, /*#__PURE__*/_react.default.createElement(_BaseDialog.DialogContent, null, /*#__PURE__*/_react.default.createElement(_Content.MainSection, {
    scrollRef: scrollRef,
    hasHeader: header !== undefined
  }, children)), /*#__PURE__*/_react.default.createElement(_BaseDialog.DialogFooter, null, /*#__PURE__*/_react.default.createElement(_Footer.Footer, {
    shadowHidden: atBottom !== false
  }, controls)));
};

exports.Dialog = Dialog;