"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ListItemContainer = void 0;

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _reactHooksShareable = require("react-hooks-shareable");

var _designparams = require("../designparams");

var _Icon = require("../Icon");

var _Typography = require("../Typography");

var _Tooltip = require("../Tooltip");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * For keyboard interaction
 */
var MenuKeys;

(function (MenuKeys) {
  MenuKeys["Enter"] = "Enter";
})(MenuKeys || (MenuKeys = {}));

var ListItemContainerWrapper = _styledComponents.default.div.withConfig({
  displayName: "ListItemContainer__ListItemContainerWrapper",
  componentId: "sc-1p9wpf8-0"
})(["background-color:", ";box-sizing:border-box;color:", ";cursor:pointer;display:inline-flex;fill:", ";flex-direction:column-reverse;height:40px;overflow:hidden;position:relative;user-select:none;width:100%;", " ", " ", ""], _ref => {
  var {
    theme
  } = _ref;
  return theme.color.background00();
}, _ref2 => {
  var {
    theme
  } = _ref2;
  return theme.color.text03();
}, _ref3 => {
  var {
    theme
  } = _ref3;
  return theme.color.text03();
}, _ref4 => {
  var {
    hasChildren,
    expanded
  } = _ref4;
  return hasChildren ? (0, _styledComponents.css)(["&::after{border-right:2px solid currentColor;border-top:2px solid currentColor;content:'';color:", ";display:block;height:8px;margin-top:", ";pointer-events:none;position:absolute;right:", ";top:50%;transform:translateY(-50%) ", ";transform-origin:4px 4px;transition:all 0.25s ease-in-out 0s;width:8px;}"], _ref5 => {
    var {
      theme
    } = _ref5;
    return theme.color.text05();
  }, () => expanded ? '2px' : '-2px', _designparams.spacing.large, () => expanded ? 'rotateZ(-45deg)' : 'rotateZ(135deg)') : undefined;
}, _ref6 => {
  var {
    theme,
    selected
  } = _ref6;
  return selected ? (0, _styledComponents.css)(["color:", ";fill:", ";background-color:", ";font-weight:", ";"], theme.color.text01(), theme.color.text01(), theme.color.element15(), theme.font.fontWeight.semibold) : undefined;
}, _ref7 => {
  var {
    selected,
    childSelected
  } = _ref7;
  return !selected && !childSelected ? (0, _styledComponents.css)(["margin-right:", ";"], _designparams.spacing.small) : undefined;
});

var ListItemMarker = _styledComponents.default.div.withConfig({
  displayName: "ListItemContainer__ListItemMarker",
  componentId: "sc-1p9wpf8-1"
})(["content:'';position:absolute;flex:none;background-color:", ";transition:all 500ms cubic-bezier(0.57,0.67,0.015,1.005);border-radius:", " 0 0 ", ";width:4px;height:80%;right:0;top:50%;", ""], _ref8 => {
  var {
    theme,
    childSelected
  } = _ref8;
  return childSelected ? theme.color.text05() : theme.color.elementPrimary();
}, _designparams.shape.radius.medium, _designparams.shape.radius.medium, _ref9 => {
  var {
    selected,
    childSelected,
    expanded
  } = _ref9;
  return (0, _styledComponents.css)(["transform:", ";"], !expanded && (selected || childSelected) ? 'scaleY(1) translateY(-50%)' : 'scaleY(0)');
});

var Label = (0, _styledComponents.default)(_Typography.Typography).attrs({
  variant: 'default-text'
}).withConfig({
  displayName: "ListItemContainer__Label",
  componentId: "sc-1p9wpf8-2"
})(["margin-right:", ";white-space:nowrap;"], _designparams.spacing.huge);

var ListItemContents = _styledComponents.default.div.withConfig({
  displayName: "ListItemContainer__ListItemContents",
  componentId: "sc-1p9wpf8-3"
})(["align-items:center;display:inline-flex;height:100%;overflow:hidden;outline:none;border:2px solid transparent;padding-left:", ";&:hover{background-color:", ";}&:focus{border:2px solid ", ";}"], _ref10 => {
  var {
    isNestedItem
  } = _ref10;
  return isNestedItem ? _designparams.spacing.huge : _designparams.spacing.extraLarge;
}, _ref11 => {
  var {
    theme
  } = _ref11;
  return theme.color.background04();
}, _ref12 => {
  var {
    theme
  } = _ref12;
  return theme.color.textPrimary();
});

var ListItemContentsIcon = (0, _styledComponents.default)(_Icon.Icon).withConfig({
  displayName: "ListItemContainer__ListItemContentsIcon",
  componentId: "sc-1p9wpf8-4"
})(["flex:none;margin-right:", ";fill:", ";color:", ";width:16px;height:16px;"], _designparams.spacing.medium, _ref13 => {
  var {
    theme,
    selected
  } = _ref13;
  return selected ? theme.color.elementPrimary() : theme.color.text05();
}, _ref14 => {
  var {
    theme,
    selected
  } = _ref14;
  return selected ? theme.color.text01() : theme.color.text05();
});

/**
 * Used to show a tooltip if label is too long to be fully shown in container.
 */
var LabelOverflowTooltip = _ref15 => {
  var {
    label
  } = _ref15;
  var {
    hasOverflow,
    ref
  } = (0, _reactHooksShareable.useHasOverflow)();

  var text = /*#__PURE__*/_react.default.createElement(Label, {
    ref: ref
  }, label);

  return hasOverflow ? /*#__PURE__*/_react.default.createElement(_Tooltip.Tooltip, {
    variant: "expanded",
    contents: /*#__PURE__*/_react.default.createElement(_Tooltip.ExpandedTooltipTypography, null, label)
  }, /*#__PURE__*/_react.default.createElement(Label, null, label)) : text;
};
/**
 * ListItemContainer
 *
 * The ListItemContainer component is used for the styling of the list item.
 * Label, icon, marker, selected item with and without nested items
 * are styled according to the design spec that can be found
 * at the top of index.ts file
 *
 */


var ListItemContainer = _ref16 => {
  var {
    selected,
    isNestedItem,
    hasChildren,
    expanded,
    childSelected,
    onClick,
    icon,
    label
  } = _ref16;
  var handleKeyDown = (0, _react.useCallback)(event => {
    if (event.key !== MenuKeys.Enter) {
      return;
    }

    event.preventDefault();

    if (onClick !== undefined) {
      onClick();
    }
  }, [onClick]);
  return /*#__PURE__*/_react.default.createElement(ListItemContainerWrapper, {
    selected: selected,
    isNestedItem: isNestedItem,
    hasChildren: hasChildren,
    expanded: expanded,
    childSelected: childSelected
  }, /*#__PURE__*/_react.default.createElement(ListItemMarker, {
    selected: selected,
    childSelected: childSelected,
    expanded: expanded
  }), /*#__PURE__*/_react.default.createElement(ListItemContents, {
    isNestedItem: isNestedItem,
    onClick: onClick,
    onKeyDown: handleKeyDown,
    tabIndex: 0
  }, /*#__PURE__*/_react.default.createElement(ListItemContentsIcon, {
    icon: icon,
    selected: selected
  }), /*#__PURE__*/_react.default.createElement(LabelOverflowTooltip, {
    label: label
  })));
};

exports.ListItemContainer = ListItemContainer;