import React from 'react';
export interface Tick {
    /**
     * Position of the tick along the slider
     */
    readonly position: number;
    /**
     * Label for the tickMarker, eg. `°`
     */
    readonly label?: string;
    /**
     * If to display the marker or not. Default `true`
     */
    readonly marker?: boolean;
}
export declare const TickLabelContainer: import("styled-components").StyledComponent<"div", import("styled-components").DefaultTheme, {}, never>;
export declare const TickMarker: React.FC<Omit<Tick, 'label'>>;
interface TickLabelProps {
    /**
     * The value to display for the tick.
     * Is overriden by `label`
     */
    readonly value: number;
    /**
     * Position of the tick along the slider
     */
    readonly position: number;
    /**
     * Label for the tickMarker, eg. `°`
     */
    readonly label?: string;
    /**
     * Executes JavaScript when clicking the value.
     */
    readonly handleChange: (value: number) => void;
}
export declare const TickLabel: React.FC<TickLabelProps>;
export {};
